function MemotooThunderbirdSettings(memotoothunderbird) { this._init(memotoothunderbird); }

MemotooThunderbirdSettings.prototype = {
  _memotoothunderbird:null,

  _init:function(memotoothunderbird) { this._memotoothunderbird = memotoothunderbird; },	
	
	get _prefroot() { return "extensions.memotoothunderbird"; },

  //set prefUrl(str) { this._setPref("", "url", str); },
  set prefUrl(str) {  },
  get prefUrl() { return this._getPref("", "url", "http://www.memotoo.com/contactsLDIF.php"); },

  set prefLogin(str) { this._setPref("", "login", str); },
  get prefLogin() { return this._getPref("", "login", ""); },
  
  set prefPassword(str) { this._setPref("", "password", str); },
  get prefPassword() { return this._getPref("", "password", ""); },

  set prefIsUploader(b) { this._setBool("", "isuploader", b); },
  get prefIsUploader() { return this._getBool("", "isuploader", false); },

  set prefIsDownloader(b) { this._setBool("", "isdownloader", b); },
  get prefIsDownloader() { return this._getBool("", "isdownloader", false); },

  set prefSyncOnLoad(b) { this._setBool("", "autodownload", b); },
  get prefSyncOnLoad() { return this._getBool("", "autodownload", false); },

  set prefSyncOnExit(b) { this._setBool("", "autoupload", b); },
  get prefSyncOnExit() { return this._getBool("", "autoupload", false); },

  _setOpts:function(mod, str) { nsPreferences.setUnicharPref(this._prefroot + mod, str); },
  _getOpts:function(mod) { return nsPreferences.copyUnicharPref(this._prefroot + mod, ""); },

  _setInt:function(mod, name, value) { this._setPref(mod, name, value); },
  _getInt:function(mod, name, dfault) { return parseInt(this._getPref(mod, name, dfault)); },

  _setBool:function(mod, name, value) { this._setInt(mod, name, (value) ? 1 : 0); },
  _getBool:function(mod, name, dfault) { return (this._getInt(mod, name, dfault) == 1) ? true : false; },

  _setPref:function(mod, name, value) {
    var newopts = "";

    // remove the name from the current options, if it exists
    var pairs = this._getOpts(mod).split("&");
    for (var idx = 0; idx < pairs.length; idx++) {
      var pair = pairs[idx].split("=");
      if ((pair[0] != name) && (pairs[idx] != "")) {
        newopts += pairs[idx] + "&";
      }
    }

    // add the new string to the options & save the options
    newopts += name + "=" + escape(value);
    this._setOpts(mod, newopts);
  },
  
  _getPref:function(mod, name, dfault) {
    // scan for the name
    var pairs = this._getOpts(mod).split("&");
    for (var idx = 0; idx < pairs.length; idx++) {
      var pair = pairs[idx].split("=");
      if (pair[0] == name) {
        return unescape(pair[1]);
      }
    }

    // still here?  not found...
    return dfault;
  },
};